<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="教练名字" prop="jlName">
        <el-input
          v-model="queryParams.jlName"
          placeholder="请输入教练名字"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="结算状态" prop="payState">
        <el-select v-model="queryParams.payState" placeholder="请选择结算状态" clearable>
          <el-option
            v-for="dict in dict.type.pay_state"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>-->
      <el-form-item label="开始日期" prop="payStartTime">
        <el-date-picker
          v-model="queryParams.payStartTime"
          type="date"
          value-format="yyyy-MM-dd"
          @change="change"
          placeholder="选择日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="结束日期" prop="payEndTime">
        <el-date-picker
          v-model="queryParams.payEndTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择日期">
        </el-date-picker>
      </el-form-item>

<!--      <el-form-item label="订单编号" prop="orderNumber">
        <el-input
          v-model="queryParams.orderNumber"
          placeholder="请输入订单编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
<!--      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>-->
<!--      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="passList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="教练名字" align="center" prop="jlName" />
      <el-table-column label="已结算金额(元)" align="center" prop="deduct" />
      <el-table-column label="未结算金额(元)" align="center" prop="deducts" />
      <el-table-column label="结算时间" align="center" prop="paydTime" />
<!--      <el-table-column label="课程金额(元)" align="center" prop="coursePrice" />
      <el-table-column label="订单编号" align="center" prop="orderNumber" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
<!--          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>-->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="jljs(scope.row)"
          >结算</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改考试通过对话框 -->
<!--    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="姓名" prop="name">
          <el-input v-model="form.name" placeholder="请输入姓名" />
        </el-form-item>
        <el-form-item label="手机号" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入手机号" />
        </el-form-item>
        <el-form-item label="科目" prop="courseSubject">
          <el-select v-model="form.courseSubject" placeholder="请选择科目">
            <el-option
              v-for="dict in dict.type.drive_course_subject"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="教练名字" prop="jlName">
          <el-input v-model="form.jlName" placeholder="请输入教练名字" />
        </el-form-item>
        <el-form-item label="提成金额(元)" prop="deduct">
          <el-input v-model="form.deduct" placeholder="请输入提成金额(元)" />
        </el-form-item>
        <el-form-item label="考试通过截图" prop="photo">
          <image-upload v-model="form.photo"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>-->
  </div>
</template>

<script>
import { listPass, getPass, delPass, addPass, updatePass ,getBalanceList,pay,getTime} from "./api/pass";

export default {
  name: "Pass",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 考试通过表格数据
      passList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        jxId: null,
        name: null,
        phone: null,
        userId: null,
        jlId: null,
        courseSubject: null,
        jlName: null,
        deduct: null,
        payState: '',
        payTime: null,
        courseId: null,
        coursePrice: null,
        orderNumber: null,
        photo: null,
        payStartTime: null,
        payEndTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "姓名不能为空", trigger: "blur" }
        ],
        phone: [
          { required: true, message: "手机号不能为空", trigger: "blur" }
        ],
        courseSubject: [
          { required: true, message: "科目不能为空", trigger: "change" }
        ],
        jlName: [
          { required: true, message: "教练名字不能为空", trigger: "blur" }
        ],
        deduct: [
          { required: true, message: "提成金额不能为空", trigger: "blur" }
        ],
        coursePrice: [
          { required: true, message: "课程金额不能为空", trigger: "blur" }
        ],
        orderNumber: [
          { required: true, message: "订单编号不能为空", trigger: "blur" }
        ],
        photo: [
          { required: true, message: "考试通过截图不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getBalanceList();
    this.getTime();
  },
  methods: {
    jljs(item){
      let data = {
        jlId:item.jlId,
        payStartTime:this.queryParams.payStartTime,
        payEndTime:this.queryParams.payEndTime
      }
      this.$modal.confirm('是否确认结算？').then(function() {
        return pay(data);
      }).then(() => {
        this.getBalanceList();
        this.$modal.msgSuccess("结算成功");
      }).catch(() => {});
    },
    change(e){
      console.log(e)
    },
    /** 查询考试通过列表 */
    getList() {
      this.loading = true;
      listPass(this.queryParams).then(response => {
        this.passList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    getBalanceList() {
      this.loading = true;
      console.log("252",this.queryParams)
      getBalanceList(this.queryParams).then(response => {

        this.passList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    getTime() {
      this.loading = true;
      getTime(this.queryParams).then(response => {
        console.log("259",response.data)
        this.queryParams.payStartTime = response.data.payStartTime;
        this.queryParams.payEndTime = response.data.payEndTime;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        jxId: null,
        name: null,
        phone: null,
        userId: null,
        jlId: null,
        courseSubject: null,
        jlName: null,
        deduct: null,
        payTime: null,
        courseId: null,
        coursePrice: null,
        orderNumber: null,
        photo: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getBalanceList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加考试通过";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPass(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改考试通过";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePass(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPass(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除考试通过编号为"' + ids + '"的数据项？').then(function() {
        return delPass(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('drivingSchool/system/pass/export', {
        ...this.queryParams
      }, `pass_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
